
; CC5X Version 3.4E, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  23. Mar 2011  21:51  *************

	processor  16F819
	radix  DEC

	__config 0x2F38

INDF        EQU   0x00
TMR0        EQU   0x01
STATUS      EQU   0x03
FSR         EQU   0x04
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
INTCON      EQU   0x0B
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
IRP         EQU   7
OPTION_REG  EQU   0x81
T1CON       EQU   0x10
ADRESH      EQU   0x1E
ADCON0      EQU   0x1F
OSCCON      EQU   0x8F
ADRESL      EQU   0x9E
ADCON1      EQU   0x9F
EEDATA      EQU   0x10C
EEADR       EQU   0x10D
EEDATH      EQU   0x10E
EEADRH      EQU   0x10F
ADON        EQU   0
GO          EQU   2
RD          EQU   0
EEPGD       EQU   7
PORTQ       EQU   0x06
ZulaufTemp  EQU   0x29
KWTemp      EQU   0x2B
WWTemp      EQU   0x2C
TrommelTemp EQU   0x2D
TrommelInt  EQU   0x2E
TrommelCount EQU   0x30
ZielTemp    EQU   0x32
med_a       EQU   0x33
med_b       EQU   0x35
med_c       EQU   0x37
Gesamtzeit  EQU   0x39
SubSeczeit  EQU   0x3B
Wasserloszeit EQU   0x3D
Zulaufzeit  EQU   0x3F
akt_status  EQU   0x41
fcode       EQU   0x42
v1_count    EQU   0x43
v_overl_cnt EQU   0x44
v_overl_req EQU   0
overl_ak_kw EQU   1
overl_ak_wk EQU   2
V_IN1_old   EQU   3
V_IN1       EQU   4
T_PROG      EQU   5
T_VORW      EQU   6
VORWAESCHE  EQU   7
Vorw_Pause_Merker EQU   0
T_PROG_old  EQU   1
T_VORW_old  EQU   2
changed     EQU   3
Update_Prog EQU   4
Text        EQU   0x47
lcdport     EQU   0x58
lcdlight    EQU   0x59
q           EQU   0x5A
svrWREG     EQU   0x70
svrSTATUS   EQU   0x20
ms          EQU   0x27
data        EQU   0x25
buff        EQU   0x26
mode        EQU   0x24
__putstr    EQU   0x21
__ps        EQU   0x22
zeile       EQU   0x21
position    EQU   0x22
buff_2      EQU   0x23
i           EQU   0x21
Num         EQU   0x21
n1          EQU   0x23
n2          EQU   0x25
REM         EQU   0x22
LOOPCOUNT   EQU   0x24
ADCON0_2    EQU   0x21
temp2       EQU   0x21
temp        EQU   0
temp2_2     EQU   1
Solltemp    EQU   0x21
ci          EQU   0x23
TtmpA69     EQU   0x45

	GOTO main

  ; FILE C:\projekte\picsel\wimix\wimix.c
			;/* WIMIX Wasser-Impulsmixer Waschmaschinen-Vorschaltgeraet             */
			;/*                       __    _                                       */                     
			;/*            __________/ /_  (_)________   ___  __  __                */       
			;/*           / ___/ ___/ __ \/ / ___/ __ \ / _ \/ / / /                */ 
			;/*          (__  ) /__/ / / / / /  / /_/ //  __/ /_/ /                 */ 
			;/*         /____/\___/_/ /_/_/_/  / .___(_)___/\__,_/                  */ 
			;/*                               /_/                                   */ 
			;/*                                                                     */ 
			;/* (c) C.Schirp released under the creative commons BY-NC-SA license   */
			;/*     for further details see                                         */ 
			;/*     http://creativecommons.org/licenses/by-nc-sa/3.0/               */ 
			;/*     schirp.eu must be named in derived software coyright notes      */
			;/*                                                                     */
			;/*    V1.0  Erstausgabe 08.02.2011                                     */
			;/*    V1.1  Zahlenformat gendert, AD-Werte skaliert                   */
			;/*    V1.11 Update KW-Temperatur auch im PURGE-Status, Shutdown        */
			;/*          mit mehr Stromsparen                                       */
			;/*    V1.2  Zulaufmengenbegrenzung hinzu, Fehlertexte                  */
			;/*                                                                     */
			;
			;#include <c:\projekte\picsel\cc5\16F819.h>
			;#include <c:\projekte\picsel\cc5\int16CXX.h>
			;#include <c:\projekte\picsel\cc5\inline.h>
			;
			;#pragma config = 0b.0010.1111.0011.1000 
			;
			;
			;
			;/* ====================== Port- Defines ====================== */
			;
			;#define LCD_RS    0b.00001000             //RS-Pin ist Bit3, LCD Register Select
			;#define LCD_CS    0b.00000100             //E-Pin ist Bit2, LCD Chip Select
			;#pragma char PORTQ @ PORTB                //PORT auswhlen, DB7-Bit7, DB6-Bit6, DB5-Bit5, DB4-Bit4
			;
			;#define KW_VENTIL PORTB.0			// Kaltwasser-Ventilausgang
			;#define WW_VENTIL PORTB.1			// Warmwasser-Ventilausgang
			;#define VENTIL_IN1 PORTA.1			// Ventileinang 1 
			;#define TASTE_PROG PORTA.3			// Tasteneingang Programm
			;#define TASTE_VORW PORTA.4			// Tasteneingang Vorwaesche
			;#define LCD_BACKLIT PORTA.6		// Backlight
			;#define LED_OFF PORTA.7			// LED
			;
			;
			;/* ====================== Kommandos fr das LCD-Display ====================== */
			;#define CLEAR_DISPLAY 0x01
			;#define OFF_DISPLAY   0x08
			;#define CURSOR_OFF    0x0C
			;#define CURSOR_ON     0x0E
			;#define CURSOR_BLINK  0x0F
			;#define SHIFT_LEFT    0x18
			;#define SHIFT_RIGHT   0x1C
			;
			;/* ====================== Programmkonstanten ====================== */
			;#define LCD_LENGTH    17
			;#define Hund Text+0
			;#define Tens Text+1
			;#define Ones Text+2
			;
			;#define CGRAM_LEN	24  //Anzahl zu bertragender Zeichen
			;
			;#define ST_IDLE		0
			;#define ST_MIX		1
			;#define ST_PURGE	2
			;#define ST_FAIL		3
			;
			;#define TEMP_OFFS      237	// Offset AD-Wert bei 0Grad
			;#define TEMP_MAX       121	// Maximaler AD-Wert
			;#define TEMP_TM0       20 //1260	// Trommel-Integral Startwert (Temperatur x Masse)  	
			;#define TEMP_CNT0	1 //30	// Vorbelegung der Trommel fr TM0
			;
			;#define TEMPSCALE 175	// Steigung ADC, KTY81 und Rvor: 0,64/Bit -> 0,63*256 = 161 (gemessen: 177)
			;
			;#define MIXZEIT_MAX 900 	// Zeit fr Warmwasser-Zulauf 15 Minuten = 15x 60 Sekunden
			;#define VORWZEIT_PAUSE 300	// Zeit ohne Wasserbezug, ab der auf Haupwaesche geschaltet wird
			;#define VORW_TEMP 20		// Zieltemperatur fr Vorwsche
			;#define ZULAUFZEIT_MAX 	860	// Maximale Zeit mit aktivem Wasserzulauf... Wasserstop-Funktion (100 l bei 7l/min)
			;
			;#define LCD_LIGHT	15	// Zeit fr Backlight an in Sekunden
			;
			;#define F_NONE	0	// kein Fehler
			;#define F_LOWT 	1	// untertemperatur
			;#define F_OVERT	2	// Uebertemp
			;#define F_FUELLZEIT 3	// Fuellzeit lnger als ZULAUFZEIT_MAX
			;
			;#define VENTIL_CNT_MAX 6 // Anzahl 2ms-Perioden fr Ventileingangserkennung
			;
			;#define VENTIL_AUF 0	// defines fr die Low-Aktiven Ventile
			;#define VENTIL_ZU 1
			;
			;#define VENTIL_OVERLAP	50 // Anzahl 2,5ms-Scheiben, die beide Ventile beim Wechsel offen sind
			;
			;
			;/* ====================== Funktionsprototypen, Makros etc. ====================== */
			;#define LCDCS_ON() { NOP;  NOP; lcdport|=LCD_CS; PORTQ=lcdport; }
			;#define LCDCS_OFF() { NOP;  NOP; lcdport&=~LCD_CS; PORTQ=lcdport; }
			;#define LCDRS_ON() { NOP;  NOP; lcdport|=LCD_RS; PORTQ=lcdport; }
			;#define LCDRS_OFF() { NOP; NOP; lcdport&=~LCD_RS; PORTQ=lcdport; }
			;
			;#define Wait() Delay1ms(10)
			;
			;/* ======================  Variablen ====================== */
			;
			;bank0 uns16 ZulaufTemp;	// aktuell gemessene ZulaufTemperatur
			;bank0 uns8 KWTemp;	// zuletzt gemessene Kaltwasser Temperatur
			;bank0 uns8 WWTemp;	// zuletzt gemessene Warmwasser Temperatur
			;bank0 uns8 TrommelTemp;// berechnete TrommelTemperatur
			;bank0 uns16 TrommelInt;	// Trommeltemperatur-Integral
			;bank0 uns16 TrommelCount;	// Trommeltemperatur-Integral
			;bank0 uns8 ZielTemp;	// Zieltemperatur (=Programm)
			;
			;int16 med_a;
			;int16 med_b;
			;int16 med_c;
			;
			;bank0 uns16 Gesamtzeit;	// gemessene Zeit seit Start in Sekunden
			;bank0 uns16 SubSeczeit;	// Zeitslots innerhalb einer Sekunde
			;bank0 uns16 Wasserloszeit;// Zeit ohne Wasserbezug
			;bank0 uns16 Zulaufzeit;	// Zeit mit aktivem Wasserbezug
			;
			;uns8 akt_status;	// Zentrale Statusvariable
			;uns8 fcode;		// Fehlercode
			;uns8 v1_count;		// Hilfsvariable zum Entprellen der 50Hz-Ventilsignale
			;//uns8 v2_count;
			;
			;uns8 v_overl_cnt;	// Rckwrtszhler fr Ventil-berlappzeit
			;bit  v_overl_req;	// welches Ventil soll verzgert getoggelt werden? 0=KW 1=WW
			;bit overl_ak_kw;	// Aknowledge-Bits fr Overlap kalt->warm 
			;bit overl_ak_wk;	// warm->kalt
			;
			;
			;bit V_IN1_old;
			;//bit V_IN2_old;
			;bit V_IN1;		// Entprellter Ventil 1 Status
			;//bit V_IN2;		// Entprellter Ventil 2 Status
			;bit T_PROG;		// Entprellte Taste Prog
			;bit T_VORW;		// Entprellte Taste Vorwsche
			;
			;bit VORWAESCHE;		// Vorwaesche gewuenscht
			;bit Vorw_Pause_Merker;	// Zulaufpause Vorwsche erreicht		
			;bit T_PROG_old;
			;bit T_VORW_old;
			;
			;bit changed;		// Taste oder Ventileingang hat sich gendert
			;bit Update_Prog;	// Update-Request fr LCD-Programmzeile
			;
			;
			;unsigned char Text[LCD_LENGTH];	// Speicher fr eine LCD-Zeile incl Nullterminierung
			;uns8 lcdport;		// temp-variable der LCD-Routinen
			;uns8 lcdlight;		// Backlight-Counter
			;
			;uns8 q[4];	// Ergebnisvariable fr divide
			;
			;
			;const unsigned char chardefs[] = {
			;//Adresse 0 im Character RAM
			;// 'raute'
			;0, 0x04, 0x0A, 0x11, 0x0A, 0x04, 0, 0,
			;
			;//Adresse 1 im Character RAM
			;// 'quadrat'
			;0, 0, 0x0e, 0x0a, 0x0e, 0, 0, 0,
			;
			;//Adresse 2 im Character RAM
			;// 'gefuelltes quadrat'
			;0, 0, 0x0e, 0x0e, 0x0e, 0, 0, 0,
			;
			;};
			;
			;
			;/*------------------------------------------------------------------*/
			;/*   II  N   N TTTTT                                                */
			;/*   II  NN  N   T                                                  */
			;/*   II  N N N   T                                                  */
			;/*   II  N  NN   T                                                  */
			;/*   II  N   N   T                                                  */
			;/*------------------------------------------------------------------*/
			;#pragma origin 4
	ORG 0x0004
			;interrupt int_server(void)
			;{
int_server
			;	int_save_registers
	MOVWF svrWREG
	SWAPF STATUS,W
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF svrSTATUS
			;	
			;	// Interrupt-Code
			;	
			;	int_restore_registers
	SWAPF svrSTATUS,W
	MOVWF STATUS
	SWAPF svrWREG,1
	SWAPF svrWREG,W
			;}
	RETFIE
			;
			;
			;
			;/*------------------------------------------------------------------*/
			;/*   II  N   N  II TTTTT                                            */
			;/*   II  NN  N  II   T                                              */
			;/*   II  N N N  II   T                                              */
			;/*   II  N  NN  II   T                                              */
			;/*   II  N   N  II   T                                              */
			;/*------------------------------------------------------------------*/
			;
			;void init (void)
			;{
_const1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF ci
	BTFSC ci,7
	GOTO  m001
	BCF   0x03,IRP
	MOVWF FSR
	MOVF  INDF,W
	RETURN
m001	MOVLW 0
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF EEADRH
	BCF   0x03,RP1
	RRF   ci,W
	ANDLW 63
	ADDLW 55
	BSF   0x03,RP1
	MOVWF EEADR
	BTFSS 0x03,Carry
	GOTO  m002
	INCF  EEADRH,1
m002	BSF   0x03,RP0
	BSF   0x03,RP1
	BSF   0x18C,EEPGD
	BSF   0x18C,RD
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC ci,0
	GOTO  m003
	BSF   0x03,RP1
	MOVF  EEDATA,W
	ANDLW 127
	RETURN
m003	BCF   0x03,RP0
	BSF   0x03,RP1
	RLF   EEDATA,W
	RLF   EEDATH,W
	RETURN
	DW    0x200
	DW    0x88A
	DW    0x20A
	DW    0x0
	DW    0x0
	DW    0x50E
	DW    0xE
	DW    0x0
	DW    0x0
	DW    0x70E
	DW    0xE
	DW    0x0
	DW    0x30EB
	DW    0x3A6C
	DW    0x2B00
	DW    0x396F
	DW    0x77
	DW    0x1020
	DW    0x1020
	DW    0x2280
	DW    0x3972
	DW    0x103A
	DW    0x2A80
	DW    0x3165
	DW    0x3965
	DW    0x32F4
	DW    0x386D
	DW    0x2A80
	DW    0x3A6E
	DW    0x3965
	DW    0x32F4
	DW    0x386D
	DW    0x2300
	DW    0x32F5
	DW    0x366C
	DW    0x32FA
	DW    0x3A69
	DW    0x30ED
	DW    0x78
	DW    0x3775
	DW    0x32E2
	DW    0x30EB
	DW    0x376E
	DW    0x74
	DW    0x2120
	DW    0x32E5
	DW    0x326E
	DW    0x3A65
	DW    0x2A00
	DW    0x36E5
	DW    0x1D70
	DW    0x2B80
	DW    0x26C9
	DW    0x3C69
	DW    0x18A0
	DW    0x192E
	DW    0x0
init
			;	/* Oszillatorblock */
			;	
			;	OSCCON = 0b0110.0000;	// 4MHz Clock - wie 16F628 mit INTRC
	MOVLW 96
	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVWF OSCCON
			;	
			;	/* PORT A Config */
			;	PORTA =  0x00;	
	BCF   0x03,RP0
	CLRF  PORTA
			;	TRISA =  0b0011.1111;	// RA0-5 input , RA6,7 Output
	MOVLW 63
	BSF   0x03,RP0
	MOVWF TRISA
			;	
			;	/* Port B Config */
			;	PORTB =  0b0000.0011;	// RB0,1 sind die Ventilausgnge... low aktiv
	MOVLW 3
	BCF   0x03,RP0
	MOVWF PORTB
			;	TRISB =  0b0000.0000;	// alles Output
	BSF   0x03,RP0
	CLRF  TRISB
			;
			;	/* ADC */
			;	ADCON0=	 0b1000.0001;	// Fosc...  Channel AN0, Stopped, AD_ON
	MOVLW 129
	BCF   0x03,RP0
	MOVWF ADCON0
			;	ADCON1 = 0b1100.1110;	// Rechtsbuendig, AD_clock/2, DDDA-Konfig
	MOVLW 206
	BSF   0x03,RP0
	MOVWF ADCON1
			;
			;	/*sonstiges*/
			;	T1CON = 0x00;		// Timer disabled
	BCF   0x03,RP0
	CLRF  T1CON
			;	OPTION_REG = 0x84;	/* pull-up porta, falling edge int, FOSC/4 source, no WDT prescaler, prescale=32 */
	MOVLW 132
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;	INTCON = 0b.0000.0000; 	// int disabled und gelscht 
	CLRF  INTCON
			;	
			;	LCD_BACKLIT = 1;	// erstmal dunkel machen
	BCF   0x03,RP0
	BSF   PORTA,6
			;
			;	/* Variablen initialisieren */
			;
			;	Text[0]= 0;
	CLRF  Text
			;	akt_status = ST_MIX;	
	MOVLW 1
	MOVWF akt_status
			;	TrommelInt = TEMP_TM0;
	MOVLW 20
	MOVWF TrommelInt
	CLRF  TrommelInt+1
			;	TrommelCount = TEMP_CNT0;
	MOVLW 1
	MOVWF TrommelCount
	CLRF  TrommelCount+1
			;	TrommelTemp = 20;
	MOVLW 20
	MOVWF TrommelTemp
			;	
			;	ZielTemp = 30;	// Default-Temperatur 30 Grad
	MOVLW 30
	MOVWF ZielTemp
			;	VORWAESCHE = 0;
	BCF   0x45,VORWAESCHE
			;	
			;	Vorw_Pause_Merker =0;
	BCF   0x46,Vorw_Pause_Merker
			;	
			;	V_IN1_old = 0;	// Eingangsmerker aktualisieren
	BCF   0x45,V_IN1_old
			;	//V_IN2_old = 0;
			;	V_IN1 = 0;
	BCF   0x45,V_IN1
			;	//V_IN2 = 0;	
			;	T_PROG = 0;		
	BCF   0x45,T_PROG
			;	T_VORW = 0;
	BCF   0x45,T_VORW
			;	T_PROG_old = TASTE_PROG;
	BCF   0x46,T_PROG_old
	BTFSC PORTA,3
	BSF   0x46,T_PROG_old
			;	T_VORW_old = TASTE_VORW;
	BCF   0x46,T_VORW_old
	BTFSC PORTA,4
	BSF   0x46,T_VORW_old
			;	
			;	
			;	overl_ak_kw = 0; // Aknowledge-Bits lschen
	BCF   0x45,overl_ak_kw
			;	overl_ak_wk = 0;
	BCF   0x45,overl_ak_wk
			;
			;	v1_count = 0;		
	CLRF  v1_count
			;	//v2_count = 0;
			;	
			;	v_overl_cnt = 0;
	CLRF  v_overl_cnt
			;	
			;	Update_Prog = 1;	// Zeile eins auch updaten
	BSF   0x46,Update_Prog
			;	
			;	Gesamtzeit = 0;
	CLRF  Gesamtzeit
	CLRF  Gesamtzeit+1
			;	SubSeczeit = 0;
	CLRF  SubSeczeit
	CLRF  SubSeczeit+1
			;	
			;	Zulaufzeit = 0;	        // Aufsummierung der Zulaufzeit zuruecksetzen
	CLRF  Zulaufzeit
	CLRF  Zulaufzeit+1
			;	
			;	lcdlight = LCD_LIGHT;	// Licht anmachen
	MOVLW 15
	MOVWF lcdlight
			;}
	RETURN
			;
			;
			;/*------------------------------------------------------------------*/
			;/*   LL    CCCC DDD                                                 */
			;/*   LL   CC    DD DD                                               */
			;/*   LL   CC    DD  DD                                              */
			;/*   LL   CC    DD DD                                               */
			;/*   LLLLL CCCC DDD                                                 */
			;/*------------------------------------------------------------------*/
			;
			;void Delay1ms(uns16 ms)
			;{
Delay1ms
			;
			;	while(ms)				// Schleife verlassen wen ms=0 ist
m004	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  ms,W
	IORWF ms+1,W
	BTFSC 0x03,Zero_
	GOTO  m007
			;	{
			;	    OPTION = 2; 		// Vorteiler auf 8 einstellen
	MOVLW 2
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;	    TMR0 = 131; 		// 125 * 8 = 1000 (= 1 ms)
	MOVLW 131
	BCF   0x03,RP0
	MOVWF TMR0
			;	    while (TMR0);		// abwarten einer Milisekunde
m005	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  TMR0,W
	BTFSC 0x03,Zero_
	GOTO  m006
	GOTO  m005
			;	    ms--;				// "ms" mit jeder Milisekunde ernidrigen
m006	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  ms,1
	INCF  ms,W
	BTFSC 0x03,Zero_
	DECF  ms+1,1
			;	}
	GOTO  m004
			;
			;}
m007	RETURN
			;
			;//*******************************************
			;// Schreibt ein Datenbyte in die LCD-Anzeige
			;// Schreibt das Byte in zwei 4 Bit Nibbles
			;//*******************************************
			;
			;void LCDWriteByte (unsigned char data)
			;{
LCDWriteByte
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF data
			;#pragma updateBank 0 /* OFF, all cores */
			; unsigned char buff;
			; lcdport= PORTQ; 		//alten Wert merken
	MOVF  PORTQ,W
	MOVWF lcdport
			; 
			; LCDCS_OFF();
	NOP  
	NOP  
	BCF   lcdport,2
	MOVF  lcdport,W
	MOVWF PORTQ
			; buff=data & 0xF0;		//High Nibble des Bytes, Rest lschen
	MOVLW 240
	ANDWF data,W
	MOVWF buff
			; lcdport=lcdport&0x0F;		//Hier D4-D7 lschen zum
	MOVLW 15
	ANDWF lcdport,1
			; lcdport|=buff;			//reinodern vom High Nibble
	MOVF  buff,W
	IORWF lcdport,1
			; lcdport|=LCD_CS;
	BSF   lcdport,2
			; LCDCS_ON();	      		//High Nibble schreiben
	NOP  
	NOP  
	BSF   lcdport,2
	MOVF  lcdport,W
	MOVWF PORTQ
			;
			; LCDCS_OFF();
	NOP  
	NOP  
	BCF   lcdport,2
	MOVF  lcdport,W
	MOVWF PORTQ
			; buff=data<<4;        	//Low Nibble des Bytes hochschieben
	SWAPF data,W
	ANDLW 240
	MOVWF buff
			; buff &= 0xF0;		// nachgeschobenes Loeschen
	MOVLW 240
	ANDWF buff,1
			; lcdport=lcdport & 0x0F;	//D4-D7  lschen zum
	MOVLW 15
	ANDWF lcdport,1
			; lcdport|=buff;			//reinodern vom Low Nibble
	MOVF  buff,W
	IORWF lcdport,1
			; LCDCS_ON();	      		//Low Nibble schreiben
	NOP  
	NOP  
	BSF   lcdport,2
	MOVF  lcdport,W
	MOVWF PORTQ
			; LCDCS_OFF();
	NOP  
	NOP  
	BCF   lcdport,2
	MOVF  lcdport,W
	MOVWF PORTQ
			; Delay1ms(1);       		// warten
	MOVLW 1
	MOVWF ms
	CLRF  ms+1
	GOTO  Delay1ms
			;#pragma updateBank 1 /* ON, all cores */
			;}
			;
			;//*****************************************
			;// Commando ans Display senden
			;//*****************************************
			;void LCDCommand(unsigned char mode)
			;{
LCDCommand
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF mode
			;#pragma updateBank 0 /* OFF, all cores */
			; lcdport= PORTQ; 		//alten Wert merken
	MOVF  PORTQ,W
	MOVWF lcdport
			; LCDRS_OFF(); 			//Controlregister
	NOP  
	NOP  
	BCF   lcdport,3
	MOVF  lcdport,W
	MOVWF PORTQ
			; LCDWriteByte(mode);
	MOVF  mode,W
	CALL  LCDWriteByte
			; LCDRS_ON(); 			//Zurck auf Datenregister
	NOP  
	NOP  
	BSF   lcdport,3
	MOVF  lcdport,W
	MOVWF PORTQ
			;#pragma updateBank 1 /* ON, all cores */
			;}
	RETURN
			;
			;//*****************************************
			;// Lscht die LCD Anzeige
			;// Cursor steht dann auf Position 1,Zeile 1
			;// Gilt auch fr mehrzeilige Anzeigen
			;//*****************************************
			;void LCDCls(void)
			;{
LCDCls
			; lcdport= PORTQ; 		//alten Wert merken
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PORTQ,W
	MOVWF lcdport
			; LCDRS_OFF(); //Controlregister
	NOP  
	NOP  
	BCF   lcdport,3
	MOVF  lcdport,W
	MOVWF PORTQ
			; LCDWriteByte(0x01); //CLS
	MOVLW 1
	CALL  LCDWriteByte
			; LCDRS_ON(); //Umschalten auf Datenregister
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   lcdport,3
	MOVF  lcdport,W
	MOVWF PORTQ
			; Wait();
	MOVLW 10
	MOVWF ms
	CLRF  ms+1
	GOTO  Delay1ms
			;}
			;//**************************************************
			;//Schreibt einen Text in die LCD-Anzeige
			;//**************************************************
			;void LCDString(const char *__putstr)
			;{
LCDString
			;//#pragma updateBank 0 /* OFF, all cores */
			; char __ps;
			;
			; __ps = *__putstr;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  __putstr,W
	CALL  _const1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF __ps
			;
			;  while(__ps>0)
m008	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  __ps,1
	BTFSC 0x03,Zero_
	GOTO  m010
			;   {
			;    __putstr++;
	INCF  __putstr,1
			;    if (__ps== 0) break;
	MOVF  __ps,1
	BTFSS 0x03,Zero_
	GOTO  m009
	GOTO  m010
			;   LCDWriteByte(__ps);
m009	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  __ps,W
	CALL  LCDWriteByte
			;    __ps = *__putstr;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  __putstr,W
	CALL  _const1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF __ps
			;   }
	GOTO  m008
			;//#pragma updateBank 1 /* ON, all cores */
			;}
m010	RETURN
			;//****************************************************
			;// Springt auf Zeile x und Position y der LCD-Anzeige
			;// Gltig fuer 2 Zeilen : 0,1.
			;//****************************************************
			;void LCDPos(unsigned char zeile,unsigned char position)
			;{
LCDPos
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF position
			;#pragma updateBank 0 /* OFF, all cores */
			;	 unsigned char buff;
			;	
			;	// 0x80 wegen Display Adress Set.
			;	// Erste Position ist bei mir  0.
			;	
			;	if (zeile)
	MOVF  zeile,1
	BTFSC 0x03,Zero_
	GOTO  m011
			;	{
			;		buff=0xC0+position;
	MOVLW 192
	ADDWF position,W
	MOVWF buff_2
			;	}
			;	else
	GOTO  m012
			;	{
			;		buff=0x80+position;
m011	MOVLW 128
	ADDWF position,W
	MOVWF buff_2
			;	}
			;	
			;	 LCDCommand(buff);
m012	MOVF  buff_2,W
	GOTO  LCDCommand
			;#pragma updateBank 1 /* ON, all cores */
			;}
			;
			;
			;//*********************************************
			;//Stellt die Funktionsweise der LCD Anzeige ein
			;//*********************************************
			;
			;void LCDInit(void)
			;{
LCDInit
			;#pragma updateBank 0 /* OFF, all cores */
			; int i;
			; 
			; lcdport= PORTQ; 	//alten Wert merken
	MOVF  PORTQ,W
	MOVWF lcdport
			;
			; LCDRS_OFF();  //Control Register
	NOP  
	NOP  
	BCF   lcdport,3
	MOVF  lcdport,W
	MOVWF PORTQ
			; LCDCS_OFF();  //LCD-Anzeige abwhlen
	NOP  
	NOP  
	BCF   lcdport,2
	MOVF  lcdport,W
	MOVWF PORTQ
			;
			;//Software Reset laut Hitachi Datenblatt
			; Delay1ms(60); //Mglichen Power On Reset abwarten
	MOVLW 60
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			; for(i=0; i<3; i++)
	CLRF  i
m013	BTFSC i,7
	GOTO  m014
	MOVLW 3
	SUBWF i,W
	BTFSC 0x03,Carry
	GOTO  m015
			;  {
			;   lcdport=lcdport&0x0F;//D4-D7 lschen
m014	MOVLW 15
	ANDWF lcdport,1
			;   lcdport|=0x30;	//Wert reinodern
	MOVLW 48
	IORWF lcdport,1
			;   PORTQ=lcdport;	//Auf den Port legen
	MOVF  lcdport,W
	MOVWF PORTQ
			;   LCDCS_OFF(); //LCD-Anzeige abwhlen
	NOP  
	NOP  
	BCF   lcdport,2
	MOVF  lcdport,W
	MOVWF PORTQ
			;   NOP;
	NOP  
			;   LCDCS_ON();	//High Nibble schreiben
	NOP  
	NOP  
	BSF   lcdport,2
	MOVF  lcdport,W
	MOVWF PORTQ
			;   Delay1ms(5); //Ein bichen warten auf die Anzeige
	MOVLW 5
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;  } 
	INCF  i,1
	GOTO  m013
			;//Ende Software Reset
			;
			;
			;//Der erste Schreibzugriff nach dem Reset ist ein 8 Bit
			;//Zugriff!! Also nur einmal schreiben, nicht Low-High Nibble.
			;
			;//Um die 4Bit Operation einzuschalten
			; lcdport=0x23;	//4 Bit Operation 2 Zeilen, untere Bits an wg. Ventilausgngen	
m015	MOVLW 35
	MOVWF lcdport
			;
			; PORTQ=lcdport;	//Auf den Port legen - ACHTUNG, Zerstrt auch die Bits0..3!
	MOVF  lcdport,W
	MOVWF PORTQ
			; NOP;
	NOP  
			;
			; LCDCS_ON();	//High Nibble schreiben
	NOP  
	NOP  
	BSF   lcdport,2
	MOVF  lcdport,W
	MOVWF PORTQ
			; NOP;
	NOP  
			; NOP; 
	NOP  
			; LCDCS_OFF();
	NOP  
	NOP  
	BCF   lcdport,2
	MOVF  lcdport,W
	MOVWF PORTQ
			; Wait();
	MOVLW 10
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			; LCDWriteByte(0x2C);    //4 Bit Operation,2 Line,5x7 Font  
	MOVLW 44
	CALL  LCDWriteByte
			; Wait();
	MOVLW 10
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			; LCDWriteByte(0x14); 	//Cursor Move,Right Shift
	MOVLW 20
	CALL  LCDWriteByte
			; Wait();
	MOVLW 10
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;
			; LCDWriteByte(0x0C); 	//Display on, Cursor off ,Cursor no blink
	MOVLW 12
	CALL  LCDWriteByte
			; Wait();
	MOVLW 10
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;
			; LCDWriteByte(0x06); 	//Increment, Display Freeze
	MOVLW 6
	CALL  LCDWriteByte
			; Wait();
	MOVLW 10
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			; LCDWriteByte(0x02); 	//Cursor Home
	MOVLW 2
	CALL  LCDWriteByte
			; Wait();
	MOVLW 10
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			; LCDRS_ON();		//LCD-Datenregister
	NOP  
	NOP  
	BSF   lcdport,3
	MOVF  lcdport,W
	MOVWF PORTQ
			;
			; LCDCommand(CLEAR_DISPLAY);
	MOVLW 1
	CALL  LCDCommand
			; Wait();
	MOVLW 10
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			; 
			;//Die eigenen Character ins CGRAM schreiben
			;
			;//Der interne Adresszhler des LCD-Displays luft
			;//nach jedem Schreibzugriff automatisch hoch
			;
			; LCDCommand(0x48);//CG_RAM Adresse(1) setzen
	MOVLW 72
	CALL  LCDCommand
			;
			; for(i=0; i<CGRAM_LEN; i++) //8 Codes pro Zeichen bertragen
	CLRF  i
m016	BTFSC i,7
	GOTO  m017
	MOVLW 24
	SUBWF i,W
	BTFSC 0x03,Carry
	GOTO  m018
			;  {
			;   LCDWriteByte(chardefs[i]);
m017	MOVLW 128
	ADDWF i,W
	CALL  _const1
	CALL  LCDWriteByte
			;  }
	INCF  i,1
	GOTO  m016
			;
			;
			; LCDCommand(0x80); //DD_RAM Adresse 0 setzen
m018	MOVLW 128
	GOTO  LCDCommand
			; 
			;#pragma updateBank 1 /* ON, all cores */
			;}
			;
			;#ifdef _DEBUG
			;/*------------------------------------------------------------------*/
			;/*  Konvertiert 16 Bit Binaer zu Hexadezimal-ASCII 4-stellig        */
			;/*------------------------------------------------------------------*/
			;void Dez4Hex(uns16 zahl)
			;{
			;	char  count, help;
			;
			;	for (count = 0; count < 4; count++)
			;	{
			;		
			;		help = zahl & 0x000F;
			;		
			;		if (help > 9)
			;		{
			;			Text[3 - count] = help + 0x37;
			;		}
			;		else
			;		{
			;			Text[3 - count] = help + 0x30;
			;		}
			;		zahl >>=4;
			;	}
			;}
			;#endif
			;
			;/*------------------------------------------------------------------*/
			;/*  Konvertiert 16 Bit Binaer zu Dezimal-ASCII 3-stellig            */
			;/*------------------------------------------------------------------*/
			;void bin2dec999(uns16 Num)
			;{
bin2dec999
			;#asm
			;;Binary to decimal conversion (0..999)
			;;
			;;Input: Num+1:Num
			;;Output Hund:Tens:Ones (-> per define auf Text[])
			;;
			;;If Input > 999 Output will roll over, e.g.
			;;for input=5678 output=678.
			;;
			;;
			;;Size: 34 instructions
			;;Execution  time  (max) including return:
			;;22+5*9-1+5*6-1+4*3-1+2 = 108 cycles
			;;
			;;5-July-2000 by Nikolai Golovchenko
			;
			;
			;        movf Num+1, w
	MOVF  Num+1,W
			;        addlw 241
	ADDLW 241
			;        addwf Num+1, w
	ADDWF Num+1,W
			;        movwf Hund      ;b_2 = 2a_2 - 15
	MOVWF Text
			;
			;        addwf Hund, w
	ADDWF Text,W
			;        addwf Hund, w
	ADDWF Text,W
			;        addlw 253
	ADDLW 253
			;        movwf Tens
	MOVWF Text+1
			;        swapf Num, w
	SWAPF Num,W
			;        andlw 0x0F
	ANDLW 15
			;        addwf Tens, f
	ADDWF Text+1,1
			;        addwf Tens, f   ;b_1 = 6a_2 + 2a_1 - 48
	ADDWF Text+1,1
			;
			;        addwf Num+1, w
	ADDWF Num+1,W
			;        sublw 251
	SUBLW 251
			;        movwf Ones
	MOVWF Text+2
			;        addwf Ones, f
	ADDWF Text+2,1
			;        addwf Ones, f
	ADDWF Text+2,1
			;        addwf Ones, f
	ADDWF Text+2,1
			;        movf Num, w
	MOVF  Num,W
			;        andlw 0x0F
	ANDLW 15
			;        addwf Ones, f   ;b_0 = a_0 - 4(a_2 + a_1) - 20
	ADDWF Text+2,1
			;
			;        movlw 10
	MOVLW 10
			;bin2dec999a                     ;9 cycles max
			;        addwf Ones, f
m019	ADDWF Text+2,1
			;        decf Tens, f
	DECF  Text+1,1
			;        btfss 3,Carry
	BTFSS 0x03,Carry
			;         goto bin2dec999a
	GOTO  m019
			;
			;bin2dec999b                     ;6 cycles max
			;        addwf Tens, f
m020	ADDWF Text+1,1
			;        decf Hund, f
	DECF  Text,1
			;        btfss 3,Carry
	BTFSS 0x03,Carry
			;         goto bin2dec999b
	GOTO  m020
			;
			;bin2dec999c                     ;3 cycles max
			;        addwf Hund, f
m021	ADDWF Text,1
			;        btfss 3,Carry
	BTFSS 0x03,Carry
			;         goto bin2dec999c
	GOTO  m021
			;
			;#endasm
			;	Text[0] +=0x30;
	MOVLW 48
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF Text,1
			;	Text[1] +=0x30;
	MOVLW 48
	ADDWF Text+1,1
			;	Text[2] +=0x30;
	MOVLW 48
	ADDWF Text+2,1
			;	Text[3] =0;
	CLRF  Text+3
			;	
			;}
	RETURN
			;
			;
			;/*------------------------------------------------------------------*/
			;/*                                                                  */
			;/*                                                                  */
			;/*                                                                  */
			;/*                                                                  */
			;/*                                                                  */
			;/*------------------------------------------------------------------*/
			;
			;/*------------------------------------------------------------------*/
			;/*   MM     MM    AA  TTTTTT HH   HH                                */
			;/*   MMM   MMM  AA  AA  TT   HH   HH                                */
			;/*   MM M M MM  AAAAAA  TT   HHHHHHH                                */
			;/*   MM  M  MM  AA  AA  TT   HH   HH                                */
			;/*   Mm     MM  AA  AA  TT   HH   HH                                */
			;/*------------------------------------------------------------------*/
			;
			;
			;
			;void mul16(uns16 n1, uns16 n2)
			;{
mul16
			;
			;#asm
			;;*******************************************************************
			;; Double Precision Multiplication
			;;
			;; n_2 : n_1 * n_4 : n_3 -> q_4:q_3:q_2:q_1
			;;
			;; Standard shift and add.
			;; Execution time: 215 to 295 clock cycles.
			;; Code space: 22 locations
			;;
			;; Cleaned up and corrected version from Microchip Ap note by BF.
			;; Note: Ap note has errors! Additional mods by Scott Dattalo.
			;;
			;;*******************************************************************
			;
			;	clrf q+3
	CLRF  q+3
			;	clrf q+2
	CLRF  q+2
			;	clrf q+1
	CLRF  q+1
			;	clrf q	
	CLRF  q
			;	bsf q+1, 7	
	BSF   q+1,7
			;m1:
			;	rrf n1+1, f
m022	RRF   n1+1,1
			;	rrf n1, f
	RRF   n1,1
			;	btfss 3,Carry  ; skpc
	BTFSS 0x03,Carry
			;	goto m2
	GOTO  m023
			;	movf n2, w
	MOVF  n2,W
			;	addwf q+2, f
	ADDWF q+2,1
			;	movf n2+1, w
	MOVF  n2+1,W
			;	btfsc 3,Carry  ; skpnc
	BTFSC 0x03,Carry
			;	incfsz n2+1, w
	INCFSZ n2+1,W
			;	addwf q+3, f
	ADDWF q+3,1
			;m2:
			;	rrf q+3, f
m023	RRF   q+3,1
			;	rrf q+2, f
	RRF   q+2,1
			;	rrf q+1, f
	RRF   q+1,1
			;	rrf q, f
	RRF   q,1
			;	btfss   3,Carry   ;skpc
	BTFSS 0x03,Carry
			;	goto m1
	GOTO  m022
			;#endasm
			;
			;}
	RETURN
			;        
			;        
			;void divide()
			;{       
divide
			;        
			;	uns16 REM;  	// Divisionsrest -> Discard
			;	uns8 LOOPCOUNT;
			;
			;#asm    
			;        
			;;Inputs:
			;;   Dividend - AARGB0:AARGB1:AARGB2 (0 - most significant!)
			;;   Divisor  - BARGB0:BARGB1
			;;Temporary:
			;;   Counter  - LOOPCOUNT
			;;   Remainder- REMB0:REMB1
			;;Output:
			;;   Quotient - AARGB0:AARGB1:AARGB2	  
			;        
			;FXD2416U:
			;            clrf REM
	CLRF  REM
			;            clrf REM+1
	CLRF  REM+1
			;            movlw .24
	MOVLW 24
			;            movwf LOOPCOUNT
	MOVWF LOOPCOUNT
			;LOOPU2416:
			;            rlf q, W           ;shift dividend left to move next bit to remainder
m024	RLF   q,W
			;            rlf q+1, F           ;
	RLF   q+1,1
			;            rlf q+2, F           ;
	RLF   q+2,1
			;        
			;            rlf REM+1, F            ;shift carry (next dividend bit) into remainder
	RLF   REM+1,1
			;            rlf REM, F
	RLF   REM,1
			;        
			;            rlf q, F           ;finish shifting the dividend and save  carry in AARGB2.0,
	RLF   q,1
			;                                    ;since remainder can be 17 bit long in some cases
			;                                    ;(e.g. 0x800000/0xFFFF). This bit will also serve
			;                                    ;as the next result bit.
			;             
			;            movf TrommelCount, W          ;substract divisor from 16-bit remainder
	MOVF  TrommelCount,W
			;            subwf REM+1, F          ;
	SUBWF REM+1,1
			;            movf TrommelCount+1, W          ;
	MOVF  TrommelCount+1,W
			;            btfss STATUS, Carry         ;
	BTFSS 0x03,Carry
			;            incfsz TrommelCount+1, W        ;
	INCFSZ TrommelCount+1,W
			;            subwf REM, F          ;
	SUBWF REM,1
			;
			;    ;here we also need to take into account the 17th bit of remainder, which
			;    ;is in AARGB2.0. If we don't have a borrow after subtracting from lower
			;    ;16 bits of remainder, then there is no borrow regardless of 17th bit 
			;    ;value. But, if we have the borrow, then that will depend on 17th bit 
			;    ;value. If it is 1, then no final borrow will occur. If it is 0, borrow
			;    ;will occur. These values match the borrow flag polarity.
			;
			;            btfsc 3,Carry           ;skpnc - if no borrow after 16 bit subtraction
	BTFSC 0x03,Carry
			;             bsf q, 0          ;then there is no borrow in result. Overwrite
	BSF   q,0
			;                                    ;AARGB2.0 with 1 to indicate no
			;                                    ;borrow.
			;                                    ;if borrow did occur, AARGB2.0 already
			;                                    ;holds the final borrow value (0-borrow,
			;                                    ;1-no borrow)
			;
			;            btfsc q, 0         ;if no borrow after 17-bit subtraction
	BTFSC q,0
			;             goto UOK46LL           ;skip remainder restoration.
	GOTO  m025
			;
			;            addwf REM, F          ;restore higher byte of remainder. (w 
	ADDWF REM,1
			;                                    ;contains the value subtracted from it
			;                                    ;previously)
			;            movf TrommelCount, W          ;restore lower byte of remainder
	MOVF  TrommelCount,W
			;            addwf REM+1, F          ;
	ADDWF REM+1,1
			;
			;UOK46LL:
			;
			;            decfsz LOOPCOUNT, f     ;decrement counter
m025	DECFSZ LOOPCOUNT,1
			;             goto LOOPU2416         ;and repeat the loop if not zero.
	GOTO  m024
			;
			; #endasm         
			;            
			;}
	RETURN
			;
			;void MedianFilter(void)
			;{
MedianFilter
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;/* Beginn Median-Filter */
			;
			;  if (med_a>med_b)
	MOVF  med_a+1,W
	SUBWF med_b+1,W
	BTFSC 0x03,Zero_
	GOTO  m026
	MOVF  med_a+1,W
	XORWF med_b+1,W
	BTFSC 0x03,Carry
	XORLW 128
	ANDLW 128
	BTFSC 0x03,Zero_
	GOTO  m027
	GOTO  m035
m026	MOVF  med_a,W
	SUBWF med_b,W
	BTFSC 0x03,Carry
	GOTO  m035
			;   if (med_a<med_c)
m027	MOVF  med_c+1,W
	SUBWF med_a+1,W
	BTFSC 0x03,Zero_
	GOTO  m028
	MOVF  med_a+1,W
	XORWF med_c+1,W
	BTFSC 0x03,Carry
	XORLW 128
	ANDLW 128
	BTFSC 0x03,Zero_
	GOTO  m029
	GOTO  m030
m028	MOVF  med_c,W
	SUBWF med_a,W
	BTFSC 0x03,Carry
	GOTO  m030
			;    ZulaufTemp = med_a;
m029	MOVF  med_a,W
	MOVWF ZulaufTemp
	MOVF  med_a+1,W
	MOVWF ZulaufTemp+1
			;   else
	GOTO  m034
			;    if (med_b<med_c)
m030	MOVF  med_c+1,W
	SUBWF med_b+1,W
	BTFSC 0x03,Zero_
	GOTO  m031
	MOVF  med_b+1,W
	XORWF med_c+1,W
	BTFSC 0x03,Carry
	XORLW 128
	ANDLW 128
	BTFSC 0x03,Zero_
	GOTO  m032
	GOTO  m033
m031	MOVF  med_c,W
	SUBWF med_b,W
	BTFSC 0x03,Carry
	GOTO  m033
			;     ZulaufTemp = med_c;
m032	MOVF  med_c,W
	MOVWF ZulaufTemp
	MOVF  med_c+1,W
	MOVWF ZulaufTemp+1
			;    else
	GOTO  m034
			;     ZulaufTemp = med_b;
m033	MOVF  med_b,W
	MOVWF ZulaufTemp
	MOVF  med_b+1,W
	MOVWF ZulaufTemp+1
			;  else
m034	GOTO  m042
			;   if (med_a>med_c)
m035	MOVF  med_a+1,W
	SUBWF med_c+1,W
	BTFSC 0x03,Zero_
	GOTO  m036
	MOVF  med_a+1,W
	XORWF med_c+1,W
	BTFSC 0x03,Carry
	XORLW 128
	ANDLW 128
	BTFSC 0x03,Zero_
	GOTO  m037
	GOTO  m038
m036	MOVF  med_a,W
	SUBWF med_c,W
	BTFSC 0x03,Carry
	GOTO  m038
			;    ZulaufTemp = med_a;
m037	MOVF  med_a,W
	MOVWF ZulaufTemp
	MOVF  med_a+1,W
	MOVWF ZulaufTemp+1
			;   else
	GOTO  m042
			;    if (med_b<med_c)
m038	MOVF  med_c+1,W
	SUBWF med_b+1,W
	BTFSC 0x03,Zero_
	GOTO  m039
	MOVF  med_b+1,W
	XORWF med_c+1,W
	BTFSC 0x03,Carry
	XORLW 128
	ANDLW 128
	BTFSC 0x03,Zero_
	GOTO  m040
	GOTO  m041
m039	MOVF  med_c,W
	SUBWF med_b,W
	BTFSC 0x03,Carry
	GOTO  m041
			;     ZulaufTemp = med_b;
m040	MOVF  med_b,W
	MOVWF ZulaufTemp
	MOVF  med_b+1,W
	MOVWF ZulaufTemp+1
			;    else
	GOTO  m042
			;     ZulaufTemp = med_c;
m041	MOVF  med_c,W
	MOVWF ZulaufTemp
	MOVF  med_c+1,W
	MOVWF ZulaufTemp+1
			;     
			;#pragma updateBank 1 /* OFF, all cores */
			;}
m042	RETURN
			;
			;
			;
			;/*------------------------------------------------------------------*/
			;/*     AA    PPPPP  PPPPP                                           */
			;/*   AA  AA  PP  PP PP  PP                                          */
			;/*  AAAAAAA  PPPPP  PPPPP                                           */
			;/*  AA   AA  PP     PP                                              */
			;/*  AA   AA  PP     PP                                              */
			;/*------------------------------------------------------------------*/
			;
			;
			;//
			;// ZulaufTempmessung ber ADC-Eingang AN0
			;// AD-Wert wird geprueft, offsetkorrigiert, skaliert in "ZulaufTemp"  geschrieben
			;//
			;// liest: -
			;// schreibt: ZulaufTemp, akt_status, fcode
			;//
			;void temp_messen(void)
			;{
temp_messen
			;//#pragma updateBank 0 /* ON, all cores */
			;
			;uns16 
			;		
			;	ADCON0=	 0b1000.0001;	// AD-Wandler rechtsbuendig, VDD=ref,  Channel AN0, Stopped, AD_ON
	MOVLW 129
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF ADCON0_2
	CLRF  ADCON0_2+1
			;	
			;	// Anmerkung zur Geschwindigkeit: AD Starten, Ergebnis kopieren, dann warten bringt nichts, da
			;	// nach jeder AD-Wandlung 16 Zyklen vor Neustart des ADC gewartet werden muss.
			;
			;	GO = 1;			// Wandlung starten
	BSF   0x1F,GO
			;	while (GO);		// Auf ADC warten
m043	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS 0x1F,GO
	GOTO  m044
	GOTO  m043
			;	
			;	// Overflow abfangen
			;	med_a.high8 = ADRESH;
m044	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  ADRESH,W
	MOVWF med_a+1
			;	med_a.low8 = ADRESL;
	BSF   0x03,RP0
	MOVF  ADRESL,W
	BCF   0x03,RP0
	MOVWF med_a
			;	
			;	GO = 1;			// Wandlung starten
	BSF   0x1F,GO
			;	while (GO);		// Auf ADC warten
m045	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS 0x1F,GO
	GOTO  m046
	GOTO  m045
			;	
			;	// Overflow abfangen
			;	med_b.high8 = ADRESH;
m046	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  ADRESH,W
	MOVWF med_b+1
			;	med_b.low8 = ADRESL;
	BSF   0x03,RP0
	MOVF  ADRESL,W
	BCF   0x03,RP0
	MOVWF med_b
			;	
			;	GO = 1;			// Wandlung starten
	BSF   0x1F,GO
			;	while (GO);		// Auf ADC warten
m047	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS 0x1F,GO
	GOTO  m048
	GOTO  m047
			;	
			;	// Overflow abfangen
			;	med_c.high8 = ADRESH;
m048	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  ADRESH,W
	MOVWF med_c+1
			;	med_c.low8 = ADRESL;
	BSF   0x03,RP0
	MOVF  ADRESL,W
	BCF   0x03,RP0
	MOVWF med_c
			;	
			;	MedianFilter(); // AD-Werte Filtern
	CALL  MedianFilter
			;	
			;	// Wertebereich prfen, Offset runter
			;	if ( ZulaufTemp > TEMP_OFFS )
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  ZulaufTemp+1,W
	BTFSS 0x03,Zero_
	GOTO  m049
	MOVLW 238
	SUBWF ZulaufTemp,W
	BTFSS 0x03,Carry
	GOTO  m052
			;	{
			;		// Okay, offset abrechnen
			;		ZulaufTemp -= TEMP_OFFS;
m049	MOVLW 237
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF ZulaufTemp,1
	BTFSS 0x03,Carry
	DECF  ZulaufTemp+1,1
			;		
			;		// Obergrenze testen
			;		if ( ZulaufTemp > TEMP_MAX )
	MOVF  ZulaufTemp+1,W
	BTFSS 0x03,Zero_
	GOTO  m050
	MOVLW 122
	SUBWF ZulaufTemp,W
	BTFSS 0x03,Carry
	GOTO  m051
			;		{
			;			// ZulaufTemp zu gross
			;			akt_status = ST_FAIL;
m050	MOVLW 3
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF akt_status
			;			fcode = F_OVERT; 	
	MOVLW 2
	MOVWF fcode
			;		}
			;	}
			;	else // ZulaufTemp zu klein
m051	GOTO  m053
			;	{
			;		akt_status = ST_FAIL;
m052	MOVLW 3
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF akt_status
			;		fcode = F_LOWT;
	MOVLW 1
	MOVWF fcode
			;	}
			;	
			;	// --- skalieren ---
			;	// Wir rechnen Fixedpoint mit 8 Nachkommabits
			;	
			;	mul16(ZulaufTemp,TEMPSCALE);	// Skalierungsfaktor einrechnen: 1 Bit -> 0,64
m053	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  ZulaufTemp,W
	MOVWF n1
	MOVF  ZulaufTemp+1,W
	MOVWF n1+1
	MOVLW 175
	MOVWF n2
	CLRF  n2+1
	CALL  mul16
			;	
			;	// Runden: wenn oberstes Bit des Nachkommateils gesetzt ist, Vorkommateil inkrementieren
			;	if (q[0].7)
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS q,7
	GOTO  m054
			;	{
			;		q[1]++;
	INCF  q+1,1
			;	}
			;	
			;	ZulaufTemp.low8  = q[1];	// Die oberen 8 Bit sind jetzt der Vorkomma-Anteil
m054	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  q+1,W
	MOVWF ZulaufTemp
			;	ZulaufTemp.high8 = 0;
	CLRF  ZulaufTemp+1
			;
			;	
			;	
			;//#pragma updateBank 1 /* ON, all cores */		
			;}
	RETURN
			;
			;//
			;// --- Eingnge lesen ---
			;// auf Tasten oder Ventileingnge testen und Entprellen, 2ms warten-> Mastertakt!
			;//
			;// liest: 
			;// schreibt: V_IN1, T_VORW, T_PROG
			;//
			;
			;void check_input(void)
			;{
check_input
			;#pragma updateBank 0 /* OFF, all cores */
			;	
			;	changed = 0;
	BCF   0x46,changed
			;	
			;	// ------ Ventileingnge --------------
			;	
			;	// Ventileingnge am uC sind Low-Aktiv!
			;	if (!VENTIL_IN1)
	BTFSC PORTA,1
	GOTO  m056
			;	{
			;		if (v1_count < VENTIL_CNT_MAX)
	MOVLW 6
	SUBWF v1_count,W
	BTFSC 0x03,Carry
	GOTO  m055
			;		{
			;			v1_count += 2;
	MOVLW 2
	ADDWF v1_count,1
			;		}
			;	}
			;	else if (v1_count >= 1)
m055	GOTO  m057
m056	MOVF  v1_count,1
	BTFSC 0x03,Zero_
	GOTO  m057
			;	{
			;		v1_count--;	
	DECF  v1_count,1
			;	}
			;	
			;	if (v1_count >= VENTIL_CNT_MAX)
m057	MOVLW 6
	SUBWF v1_count,W
	BTFSS 0x03,Carry
	GOTO  m058
			;	{
			;		// Eingang ist aktiv!
			;		V_IN1 = 1;
	BSF   0x45,V_IN1
			;	}
			;	else if (v1_count == 0)
	GOTO  m059
m058	MOVF  v1_count,1
	BTFSS 0x03,Zero_
	GOTO  m059
			;	{
			;		// Eingang ist nicht aktiv
			;		V_IN1 = 0;
	BCF   0x45,V_IN1
			;	}
			;	
			;	if (V_IN1_old ^ V_IN1)
m059	BTFSC 0x45,V_IN1_old
	GOTO  m060
	BTFSC 0x45,V_IN1
	GOTO  m061
	GOTO  m062
m060	BTFSC 0x45,V_IN1
	GOTO  m062
			;	{
			;				
			;		changed = 1;
m061	BSF   0x46,changed
			;		V_IN1_old = V_IN1;
	BCF   0x45,V_IN1_old
	BTFSC 0x45,V_IN1
	BSF   0x45,V_IN1_old
			;	}
			;	//--- 
			;	
			;	
			;	// Ventileingnge am uC sind Low-Aktiv!
			;	/*
			;	if (!VENTIL_IN2)
			;	{
			;		if (v2_count < VENTIL_CNT_MAX)
			;		{
			;			v2_count += 2;
			;		}
			;	}
			;	else if (v2_count >= 1)
			;	{
			;		v2_count--;	
			;	}
			;	
			;	if (v2_count >= VENTIL_CNT_MAX)
			;	{
			;		// Eingang ist aktiv!
			;		V_IN2 = 1;
			;	}
			;	else if (v2_count == 0)
			;	{
			;		// Eingang ist nicht aktiv
			;		V_IN2 = 0;
			;	}
			;	
			;	if (V_IN2_old ^ V_IN2)
			;	{
			;				
			;		changed = 1;
			;		V_IN2_old = V_IN2;
			;	}
			;	
			;	*/
			;	// ------ Tasteneingnge --------------
			;	if (T_PROG_old ^ TASTE_PROG)
m062	BTFSC 0x46,T_PROG_old
	GOTO  m063
	BTFSC PORTA,3
	GOTO  m064
	GOTO  m065
m063	BTFSC PORTA,3
	GOTO  m065
			;	{
			;		changed = 1;
m064	BSF   0x46,changed
			;		T_PROG = !TASTE_PROG;
	BSF   0x45,T_PROG
	BTFSC PORTA,3
	BCF   0x45,T_PROG
			;		T_PROG_old = TASTE_PROG;
	BCF   0x46,T_PROG_old
	BTFSC PORTA,3
	BSF   0x46,T_PROG_old
			;	}
			;	
			;	if (T_VORW_old ^ TASTE_VORW)
m065	BTFSC 0x46,T_VORW_old
	GOTO  m066
	BTFSC PORTA,4
	GOTO  m067
	GOTO  m068
m066	BTFSC PORTA,4
	GOTO  m068
			;	{
			;		changed = 1;
m067	BSF   0x46,changed
			;		T_VORW = !TASTE_VORW;
	BSF   0x45,T_VORW
	BTFSC PORTA,4
	BCF   0x45,T_VORW
			;		T_VORW_old = TASTE_VORW;
	BCF   0x46,T_VORW_old
	BTFSC PORTA,4
	BSF   0x46,T_VORW_old
			;	}
			;	
			;#pragma updateBank 1 /* ON, all cores */		
			;}
m068	RETURN
			;
			;//
			;// --- Tasten auswerten  ---
			;//
			;// Auswertung entprellter Tasten, Zielprogramm und Vorwsche festlegen
			;// setzt Entrpellte Tasten auf 0 zurck als Besttigung
			;//
			;// liest: T_PROG, T_VORW
			;// schreibt: ZielTemp, VORWAESCHE, T_PROG, T_VORW 
			;// 
			;void update_tasten(void)
			;{
update_tasten
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	// Tastenbedienung immer mglich
			;	if (T_PROG)
	BTFSS 0x45,T_PROG
	GOTO  m072
			;	{
			;		if (ZielTemp == 0)
	MOVF  ZielTemp,1
	BTFSS 0x03,Zero_
	GOTO  m069
			;		{
			;			ZielTemp = 30;
	MOVLW 30
	MOVWF ZielTemp
			;		}
			;		else if (ZielTemp < 60)
	GOTO  m071
m069	MOVLW 60
	SUBWF ZielTemp,W
	BTFSC 0x03,Carry
	GOTO  m070
			;		{
			;			ZielTemp += 10;
	MOVLW 10
	ADDWF ZielTemp,1
			;		}
			;		else if (ZielTemp == 60)
	GOTO  m071
m070	MOVF  ZielTemp,W
	XORLW 60
	BTFSS 0x03,Zero_
	GOTO  m071
			;		{
			;			ZielTemp = 0;
	CLRF  ZielTemp
			;		}
			;		
			;		T_PROG = 0; // Taste besttigen
m071	BCF   0x45,T_PROG
			;		Update_Prog = 1;
	BSF   0x46,Update_Prog
			;		lcdlight = LCD_LIGHT;	// Licht anmachen
	MOVLW 15
	MOVWF lcdlight
			;	}
			;	
			;	if (T_VORW)
m072	BTFSS 0x45,T_VORW
	GOTO  m073
			;	{
			;		VORWAESCHE ^= 1;
	MOVLW 128
	XORWF TtmpA69,1
			;		T_VORW = 0; // Taste besttigen
	BCF   0x45,T_VORW
			;		Update_Prog = 1;
	BSF   0x46,Update_Prog
			;		lcdlight = LCD_LIGHT;	// Licht anmachen
	MOVLW 15
	MOVWF lcdlight
			;	}
			;		
			;#pragma updateBank 1 /* ON, all cores */		
			;}
m073	RETURN
			;
			;
			;//
			;// --- Statemachine bedienen ---
			;//
			;// Zeitrechnung, Status bzw. Programmfortschritt, Trommeltemperaturberechnung
			;//
			;// liest: SubSeczeit, Gesamtzeit, VORWAESCHE, TrommelInt, TrommelCount, changed, akt_status
			;// schreibt: SubSeczeit, Gesamtzeit, changed, VORWAESCHE, TrommelInt, TrommelCount, akt_status, TrommelTemp, q[], Zulaufzeit
			;//
			;void update_state(void)
			;{
update_state
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;uns8 temp2;
			;
			;	// --- Zeitrechnung updaten ---
			;
			;	SubSeczeit++;
	INCF  SubSeczeit,1
	BTFSC 0x03,Zero_
	INCF  SubSeczeit+1,1
			;	
			;	// 1 Sec um? (gemessener Wert: 318 ticks / 3,1ms Ticktime)
			;	if (SubSeczeit > 318)
	MOVLW 1
	SUBWF SubSeczeit+1,W
	BTFSS 0x03,Carry
	GOTO  m076
	BTFSS 0x03,Zero_
	GOTO  m074
	MOVLW 63
	SUBWF SubSeczeit,W
	BTFSS 0x03,Carry
	GOTO  m076
			;	{
			;		Gesamtzeit++;	// Gesamtzeit updaten
m074	INCF  Gesamtzeit,1
	BTFSC 0x03,Zero_
	INCF  Gesamtzeit+1,1
			;		SubSeczeit = 0;
	CLRF  SubSeczeit
	CLRF  SubSeczeit+1
			;		changed = 1;	// mal nen update machen
	BSF   0x46,changed
			;		
			;		// Zeit mit/ohne Wasserbezug mitstoppen
			;		if (V_IN1)
	BTFSS 0x45,V_IN1
	GOTO  m075
			;		{
			;			Wasserloszeit=0;
	CLRF  Wasserloszeit
	CLRF  Wasserloszeit+1
			;			Zulaufzeit++;
	INCF  Zulaufzeit,1
	BTFSC 0x03,Zero_
	INCF  Zulaufzeit+1,1
			;		}
			;		else
	GOTO  m076
			;		{
			;			Wasserloszeit++;
m075	INCF  Wasserloszeit,1
	BTFSC 0x03,Zero_
	INCF  Wasserloszeit+1,1
			;		}
			;	}
			;	
			;	
			;	// --- Hier kommt die Statemachine ---
			;	
			;	
			;	if (VORWAESCHE)
m076	BTFSS 0x45,VORWAESCHE
	GOTO  m079
			;	{
			;		if (Wasserloszeit >= VORWZEIT_PAUSE)
	MOVLW 1
	SUBWF Wasserloszeit+1,W
	BTFSS 0x03,Carry
	GOTO  m078
	BTFSS 0x03,Zero_
	GOTO  m077
	MOVLW 44
	SUBWF Wasserloszeit,W
	BTFSS 0x03,Carry
	GOTO  m078
			;		{
			;			// Wenn die Pausenzeit fr Wassereinlauf bei der Vorwsche erreicht ist,
			;			// beim nchsten Zulauf die Hauptwaschgangzeit starten, Merker setzen
			;			
			;			Vorw_Pause_Merker = 1;
m077	BSF   0x46,Vorw_Pause_Merker
			;		}
			;		
			;		// Wenn die Zulaufpause erreicht war 
			;		if (Vorw_Pause_Merker)
m078	BTFSS 0x46,Vorw_Pause_Merker
	GOTO  m079
			;		{
			;			// ...und wieder Wasser angefordert wird, ist es der Hauptwaschgang
			;			if (V_IN1)
	BTFSS 0x45,V_IN1
	GOTO  m079
			;			{
			;				// Wenn die Vorwsche um ist, einfach eine neue Zeitrechnung 
			;				// ohne Vorwsche starten -> Hauptwaschgang
			;				Gesamtzeit = 0;
	CLRF  Gesamtzeit
	CLRF  Gesamtzeit+1
			;				VORWAESCHE = 0;
	BCF   0x45,VORWAESCHE
			;				SubSeczeit = 0;
	CLRF  SubSeczeit
	CLRF  SubSeczeit+1
			;				TrommelInt = TEMP_TM0;
	MOVLW 20
	MOVWF TrommelInt
	CLRF  TrommelInt+1
			;				TrommelCount = TEMP_CNT0;
	MOVLW 1
	MOVWF TrommelCount
	CLRF  TrommelCount+1
			;				changed = 1;
	BSF   0x46,changed
			;			}
			;		}
			;	}
			;	
			;	if (Gesamtzeit < MIXZEIT_MAX)
m079	MOVLW 3
	SUBWF Gesamtzeit+1,W
	BTFSS 0x03,Carry
	GOTO  m080
	BTFSS 0x03,Zero_
	GOTO  m087
	MOVLW 132
	SUBWF Gesamtzeit,W
	BTFSC 0x03,Carry
	GOTO  m087
			;	{
			;		// wenn kein Fehler, Status = mixen
			;		if (akt_status != ST_FAIL)
m080	MOVF  akt_status,W
	XORLW 3
	BTFSC 0x03,Zero_
	GOTO  m081
			;		{
			;			akt_status = ST_MIX;
	MOVLW 1
	MOVWF akt_status
			;		}
			;		
			;		// --- aktuelle Temperatur berechnen ---
			;	
			;		//Nur bei Umspringen von Sekunde oder Eingngen (Todo: beim Tastendrcken erfolgt Integralupdate...)
			;		if (changed)
m081	BTFSS 0x46,changed
	GOTO  m086
			;		{
			;			if (Gesamtzeit.1)
	BTFSS Gesamtzeit,1
	GOTO  m086
			;			{
			;				// Wenn der Zulauf an ist, ist auch eines unserer Ventile auf
			;				if (V_IN1)
	BTFSS 0x45,V_IN1
	GOTO  m086
			;				{
			;					
			;					// Kaltwasser-Temperatur korrigieren
			;					if (KW_VENTIL == VENTIL_AUF)
	BTFSC PORTB,0
	GOTO  m083
			;					{
			;						// wenn die Zulauftemperatur KW gestiegen ist (nach Umschalten von Warm z.B.)
			;						// den alten KW-Wert nehmen
			;						if (ZulaufTemp.low8 > KWTemp)
	MOVF  ZulaufTemp,W
	SUBWF KWTemp,W
	BTFSC 0x03,Carry
	GOTO  m082
			;						{
			;							ZulaufTemp.low8  =  KWTemp;
	MOVF  KWTemp,W
	MOVWF ZulaufTemp
			;						}
			;						else
	GOTO  m083
			;						{
			;							KWTemp = ZulaufTemp.low8;
m082	MOVF  ZulaufTemp,W
	MOVWF KWTemp
			;						}
			;					}
			;					
			;					// Warmwasser-Temperatur korrigieren
			;					if (WW_VENTIL == VENTIL_AUF)
m083	BTFSC PORTB,1
	GOTO  m085
			;					{
			;						// wenn die Zulauftemperatur WW gefallen ist (nach Umschalten von Kalt z.B.)
			;						// den alten WW-Wert nehmen
			;						if (ZulaufTemp.low8 < WWTemp)
	MOVF  WWTemp,W
	SUBWF ZulaufTemp,W
	BTFSC 0x03,Carry
	GOTO  m084
			;						{
			;							ZulaufTemp.low8 = WWTemp;
	MOVF  WWTemp,W
	MOVWF ZulaufTemp
			;						}
			;						else // Temperatur gleich oder gestiegen
	GOTO  m085
			;						{
			;							//Anstieg Beschleunigen wg. Trgheit der Messung
			;							temp2 = ZulaufTemp.low8 - WWTemp;
m084	MOVF  WWTemp,W
	SUBWF ZulaufTemp,W
	MOVWF temp2
			;							temp2 *=2; // Differenz x 2 zur Beschleunigung
	BCF   0x03,Carry
	RLF   temp2,1
			;							WWTemp = ZulaufTemp.low8 + temp2;
	MOVF  temp2,W
	ADDWF ZulaufTemp,W
	MOVWF WWTemp
			;							
			;							TrommelInt += temp2;
	MOVF  temp2,W
	ADDWF TrommelInt,1
	BTFSC 0x03,Carry
	INCF  TrommelInt+1,1
			;							
			;						}
			;					}
			;					
			;					
			;					TrommelInt += ZulaufTemp;
m085	MOVF  ZulaufTemp+1,W
	ADDWF TrommelInt+1,1
	MOVF  ZulaufTemp,W
	ADDWF TrommelInt,1
	BTFSC 0x03,Carry
	INCF  TrommelInt+1,1
			;					TrommelCount++;
	INCF  TrommelCount,1
	BTFSC 0x03,Zero_
	INCF  TrommelCount+1,1
			;					
			;					q[0]=TrommelInt.low8;
	MOVF  TrommelInt,W
	MOVWF q
			;					q[1]=TrommelInt.high8;
	MOVF  TrommelInt+1,W
	MOVWF q+1
			;					q[2] =0;
	CLRF  q+2
			;					
			;					divide();
	CALL  divide
			;					
			;					TrommelTemp.high8=q[1];
	MOVF  q+1,W
	MOVWF TrommelTemp
			;					TrommelTemp.low8=q[0];
	MOVF  q,W
	MOVWF TrommelTemp
			;					
			;				}	
			;			}
			;		}
			;		
			;	}
			;	else 
m086	GOTO  m088
			;	{
			;		// wenn kein Fehler, Status = mixen
			;		if (akt_status != ST_FAIL)
m087	MOVF  akt_status,W
	XORLW 3
	BTFSC 0x03,Zero_
	GOTO  m088
			;		{
			;			akt_status =ST_PURGE;
	MOVLW 2
	MOVWF akt_status
			;		}
			;		
			;	}
			;	
			;	if (Zulaufzeit > ZULAUFZEIT_MAX)
m088	MOVLW 3
	SUBWF Zulaufzeit+1,W
	BTFSS 0x03,Carry
	GOTO  m090
	BTFSS 0x03,Zero_
	GOTO  m089
	MOVLW 93
	SUBWF Zulaufzeit,W
	BTFSS 0x03,Carry
	GOTO  m090
			;	{
			;		akt_status = ST_FAIL;	// Fehlerstatus setzen
m089	MOVLW 3
	MOVWF akt_status
			;		fcode = F_FUELLZEIT; 
	MOVLW 3
	MOVWF fcode
			;	}
			;		
			;
			;#pragma updateBank 1 /* ON, all cores */
			;}
m090	RETURN
			;
			;//
			;// --- Ventilstellung updaten ---
			;//
			;// Ansteuerung der Ventile, zweipunkt-Regler
			;//
			;// liest: V_IN1, ZielTemp, akt_status, Zulaufzeit,
			;// schreibt: KW_VENTIL, WW_VENTIL
			;//
			;void update_vent(void)
			;{
update_vent
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;bit temp;	// Hilfsvariable
			;bit temp2;	// Hilfsvariable2
			;uns16 Solltemp;
			;
			;
			;	// Abfangjaeger Wasserstop: bei berschreiten der ZULAUFZEIT_MAX alle Ventile zu!
			;	if (fcode == F_FUELLZEIT)
	MOVF  fcode,W
	XORLW 3
	BTFSS 0x03,Zero_
	GOTO  m091
			;	{
			;		temp = 0;	// Fehler, also Ventile schliessen
	BCF   0x23,temp
			;	}
			;	else // ansonsten abhngig vom Ventilstatus -> Standardvorgehen
	GOTO  m092
			;	{
			;		temp = V_IN1;
m091	BCF   0x23,temp
	BTFSC 0x45,V_IN1
	BSF   0x23,temp
			;	}
			;
			;	
			;	// Einlaufventil auf? Dann regeln
			;	if (temp)
m092	BTFSS 0x23,temp
	GOTO  m105
			;	{
			;		
			;		// steht noch ein berlapp-Vorgang an?
			;		if (v_overl_cnt > 0)
	MOVF  v_overl_cnt,1
	BTFSC 0x03,Zero_
	GOTO  m094
			;		{
			;			v_overl_cnt --; // Zhler dekrementieren
	DECF  v_overl_cnt,1
			;			
			;			// jetzt null? Dann gefordertes Ventil schliessen
			;			if (v_overl_cnt == 0)
	MOVF  v_overl_cnt,1
	BTFSS 0x03,Zero_
	GOTO  m094
			;			{
			;				if (v_overl_req)
	BTFSS 0x45,v_overl_req
	GOTO  m093
			;				{
			;					WW_VENTIL = VENTIL_ZU;	
	BSF   PORTB,1
			;				}
			;				else
	GOTO  m094
			;				{
			;					KW_VENTIL = VENTIL_ZU;
m093	BSF   PORTB,0
			;				}
			;			}
			;			
			;		}
			;		
			;		// Status Purge oder Fail zusammenfassen
			;		temp = (akt_status == ST_PURGE);
m094	MOVF  akt_status,W
	XORLW 2
	BCF   0x23,temp
	BTFSC 0x03,Zero_
	BSF   0x23,temp
			;		temp2 =(akt_status == ST_FAIL);
	MOVF  akt_status,W
	XORLW 3
	BCF   0x23,temp2_2
	BTFSC 0x03,Zero_
	BSF   0x23,temp2_2
			;		temp2 |= temp;
	BTFSC 0x23,temp
	BSF   0x23,temp2_2
			;		
			;		// einfachster Fall: Kalt-Programm 
			;		if (ZielTemp == 0)
	MOVF  ZielTemp,1
	BTFSS 0x03,Zero_
	GOTO  m095
			;		{
			;			KW_VENTIL = VENTIL_AUF;
	BCF   PORTB,0
			;			overl_ak_kw = 0;	// overlap kalt->warm freigeben	
	BCF   0x45,overl_ak_kw
			;			NOP;			// zwei Nops wegen Timing read-mod-write am port
	NOP  
			;			NOP;
	NOP  
			;			WW_VENTIL = VENTIL_ZU;
	BSF   PORTB,1
			;		}
			;		else if (akt_status == ST_MIX)  // ansonsten: Regeln  in abh. vom State
	GOTO  m104
m095	DECF  akt_status,W
	BTFSS 0x03,Zero_
	GOTO  m103
			;		{
			;			
			;			// bei Vorwsche usprngliche Temperatur merken, Vorwaschtemp einstellen
			;			if (VORWAESCHE)
	BTFSS 0x45,VORWAESCHE
	GOTO  m096
			;			{
			;				Solltemp = ZielTemp;
	MOVF  ZielTemp,W
	MOVWF Solltemp
	CLRF  Solltemp+1
			;				ZielTemp = VORW_TEMP;	
	MOVLW 20
	MOVWF ZielTemp
			;			}
			;			
			;			if (TrommelTemp < ZielTemp) // Unter Ziel? Warm auf
m096	MOVF  ZielTemp,W
	SUBWF TrommelTemp,W
	BTFSC 0x03,Carry
	GOTO  m098
			;			{
			;				WW_VENTIL = VENTIL_AUF;
	BCF   PORTB,1
			;				//NOP;				// zwei Nops wegen Timing read-mod-write am port
			;				//NOP;
			;				//KW_VENTIL = VENTIL_ZU;
			;				
			;				// wenn der overlap noch nicht besttigt ist
			;				if (!overl_ak_kw) 
	BTFSC 0x45,overl_ak_kw
	GOTO  m097
			;				{
			;					v_overl_cnt = VENTIL_OVERLAP;
	MOVLW 50
	MOVWF v_overl_cnt
			;					v_overl_req = 0;
	BCF   0x45,v_overl_req
			;					overl_ak_kw = 1;	// kalt->warm aktiv
	BSF   0x45,overl_ak_kw
			;					overl_ak_wk = 0;	// warm->kalt freigeben
	BCF   0x45,overl_ak_wk
			;				}	
			;			}
			;			else if (TrommelTemp > ZielTemp) // ber Ziel: Kalt auf
m097	GOTO  m101
m098	MOVF  TrommelTemp,W
	SUBWF ZielTemp,W
	BTFSC 0x03,Carry
	GOTO  m100
			;			{
			;				KW_VENTIL = VENTIL_AUF;
	BCF   PORTB,0
			;				//NOP;				// zwei Nops wegen Timing read-mod-write am port
			;				//NOP;
			;				//WW_VENTIL = VENTIL_ZU;
			;
			;				// wenn der overlap noch nicht besttigt ist
			;				if (!overl_ak_wk) 
	BTFSC 0x45,overl_ak_wk
	GOTO  m099
			;				{
			;					v_overl_cnt = VENTIL_OVERLAP;
	MOVLW 50
	MOVWF v_overl_cnt
			;					v_overl_req = 1;
	BSF   0x45,v_overl_req
			;					overl_ak_wk = 1;	// warm->kalt aktiv
	BSF   0x45,overl_ak_wk
			;					overl_ak_kw = 0;	// kalt->warm freigeben
	BCF   0x45,overl_ak_kw
			;				}	
			;			}
			;			else  
m099	GOTO  m101
			;			{
			;				// Zieltemp genau getroffen... wenn kein Ventil auf ist-> warmwasser. Kommt vor, wenn Zulauf
			;				// zu war und die Temperatur zufllig genau auf der Mitte stand.
			;				// Im Normalbetrieb (KW oder WW auf) nichts tun, da sind wir in der Mitte der Hysterese
			;				
			;				temp = KW_VENTIL & WW_VENTIL;
m100	BSF   0x23,temp
	BTFSS PORTB,0
	BCF   0x23,temp
	BTFSS PORTB,1
	BCF   0x23,temp
			;				
			;				if (temp == VENTIL_ZU)
	BTFSS 0x23,temp
	GOTO  m101
			;				{
			;					WW_VENTIL = VENTIL_AUF;
	BCF   PORTB,1
			;					overl_ak_wk = 0;	// overlap warm->kalt freigeben
	BCF   0x45,overl_ak_wk
			;				}
			;			}
			;			
			;			// bei Vorwsche usprngliche Temperatur wiederherstellen
			;			if (VORWAESCHE)
m101	BTFSS 0x45,VORWAESCHE
	GOTO  m102
			;			{
			;				ZielTemp = Solltemp;	
	MOVF  Solltemp,W
	MOVWF ZielTemp
			;			}
			;			
			;		}
			;		else if (temp2) // bei Splstatus/Fehler nur Kaltwasser
m102	GOTO  m104
m103	BTFSS 0x23,temp2_2
	GOTO  m104
			;		{
			;			KW_VENTIL = VENTIL_AUF;	
	BCF   PORTB,0
			;			NOP;				// zwei Nops wegen Timing read-mod-write am port
	NOP  
			;			NOP;
	NOP  
			;			WW_VENTIL = VENTIL_ZU;
	BSF   PORTB,1
			;			
			;			v_overl_cnt = 0; 	// alle berlappvorgnge aus
	CLRF  v_overl_cnt
			;			
			;			// wenn die Zulauftemperatur KW aktueller (kleiner) ist, ruhig mal updaten
			;			if (ZulaufTemp.low8 < KWTemp)
	MOVF  KWTemp,W
	SUBWF ZulaufTemp,W
	BTFSC 0x03,Carry
	GOTO  m104
			;			{
			;				KWTemp = ZulaufTemp.low8;
	MOVF  ZulaufTemp,W
	MOVWF KWTemp
			;			}
			;		}	
			;	}
			;	else // Einlauf zu oder Fllzeit berschritten -> unsere Ventile auch zu
m104	GOTO  m106
			;	{
			;		KW_VENTIL = VENTIL_ZU;
m105	BSF   PORTB,0
			;		NOP;				// zwei Nops wegen Timing read-mod-write am port
	NOP  
			;		NOP;
	NOP  
			;		WW_VENTIL = VENTIL_ZU;
	BSF   PORTB,1
			;		
			;		v_overl_cnt = 0; 	// alle berlappvorgnge aus
	CLRF  v_overl_cnt
			;	}
			;	
			;	
			;#pragma updateBank 1 /* ON, all cores */
			;}
m106	RETURN
			;	
			;//
			;// --- Display update ---
			;//
			;// LCD-Ausgaben
			;// liest: Update_Prog, ZielTemp, VORWAESCHE, KW_VENTIL, WW_VENTIL, akt_status, V_IN1, TrommelTemp
			;// schreibt: KWTemp, WWTemp, Update_Prog
			;//
			;void update_LCD(void)
			;{
update_LCD
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	// Hat sich was am Programm getan -> Update
			;	if (Update_Prog)
	BTFSS 0x46,Update_Prog
	GOTO  m111
			;	{
			;		LCDPos(0,6);
	CLRF  zeile
	MOVLW 6
	CALL  LCDPos
			;		// Zieltemperatur updaten
			;		if (ZielTemp == 0)
	MOVF  ZielTemp,1
	BTFSS 0x03,Zero_
	GOTO  m107
			;		{
			;			LCDString("kalt");
	MOVLW 152
	MOVWF __putstr
	CALL  LCDString
			;		}
			;		else
	GOTO  m108
			;		{
			;			bin2dec999(ZielTemp);
m107	MOVF  ZielTemp,W
	MOVWF Num
	CLRF  Num+1
	CALL  bin2dec999
			;			Text[0]=' ';			
	MOVLW 32
	MOVWF Text
			;			Text[3]=' ';	// Rest von KALT lschen
	MOVLW 32
	MOVWF Text+3
			;			Text[4]=0;
	CLRF  Text+4
			;			LCDString(Text);
	MOVLW 71
	MOVWF __putstr
	CALL  LCDString
			;		}
			;		
			;		// Vorwsche updaten
			;		LCDPos(0,11);
m108	CLRF  zeile
	MOVLW 11
	CALL  LCDPos
			;		if (VORWAESCHE)
	BTFSS 0x45,VORWAESCHE
	GOTO  m109
			;		{
			;			LCDString("Vorw");
	MOVLW 157
	MOVWF __putstr
	CALL  LCDString
			;		}
			;		else
	GOTO  m110
			;		{
			;			LCDString("    ");
m109	MOVLW 162
	MOVWF __putstr
	CALL  LCDString
			;		}
			;		
			;		Update_Prog = 0; // Update besttigt
m110	BCF   0x46,Update_Prog
			;	}
			;	
			;	// -- dann Update zweite Zeile --
			;	
			;	
			;	// Kaltwasserteil-Update
			;	bin2dec999(KWTemp);
m111	MOVF  KWTemp,W
	MOVWF Num
	CLRF  Num+1
	CALL  bin2dec999
			;	if (KW_VENTIL == VENTIL_AUF)
	BTFSC PORTB,0
	GOTO  m112
			;	{
			;		Text[3]='+';	
	MOVLW 43
	MOVWF Text+3
			;	}
			;	else
	GOTO  m113
			;	{
			;		Text[3]='-';
m112	MOVLW 45
	MOVWF Text+3
			;	}
			;	Text[0]='K';
m113	MOVLW 75
	MOVWF Text
			;	Text[4] = ' ';
	MOVLW 32
	MOVWF Text+4
			;	Text[5] = 0;
	CLRF  Text+5
			;	
			;	LCDPos(1,0);
	MOVLW 1
	MOVWF zeile
	MOVLW 0
	CALL  LCDPos
			;	LCDString(Text);
	MOVLW 71
	MOVWF __putstr
	CALL  LCDString
			;	
			;	// Warmwasserteil-Update
			;	bin2dec999(WWTemp);
	MOVF  WWTemp,W
	MOVWF Num
	CLRF  Num+1
	CALL  bin2dec999
			;	if (WW_VENTIL == VENTIL_AUF)
	BTFSC PORTB,1
	GOTO  m114
			;	{
			;		Text[3]='+';	
	MOVLW 43
	MOVWF Text+3
			;	}
			;	else
	GOTO  m115
			;	{
			;		Text[3]='-';
m114	MOVLW 45
	MOVWF Text+3
			;	}
			;	Text[0]='W';
m115	MOVLW 87
	MOVWF Text
			;	Text[4] = ' ';
	MOVLW 32
	MOVWF Text+4
			;	Text[5] = 0;
	CLRF  Text+5
			;	
			;	LCDPos(1,5);
	MOVLW 1
	MOVWF zeile
	MOVLW 5
	CALL  LCDPos
			;	LCDString(Text);
	MOVLW 71
	MOVWF __putstr
	CALL  LCDString
			;	
			;	if (V_IN1)
	BTFSS 0x45,V_IN1
	GOTO  m116
			;	{
			;		Text[0]='Z';	
	MOVLW 90
	MOVWF Text
			;	}
			;	else
	GOTO  m117
			;	{
			;		Text[0]='-';
m116	MOVLW 45
	MOVWF Text
			;		
			;	}
			;	Text[1] = 0;
m117	CLRF  Text+1
			;	LCDString(Text);
	MOVLW 71
	MOVWF __putstr
	CALL  LCDString
			;	
			;	//Trommeltemperatur nur beim Mischen angeben (sonst unbekannt)
			;	if (akt_status == ST_MIX)
	DECF  akt_status,W
	BTFSS 0x03,Zero_
	GOTO  m118
			;	{
			;		bin2dec999(TrommelTemp);
	MOVF  TrommelTemp,W
	MOVWF Num
	CLRF  Num+1
	CALL  bin2dec999
			;		Text[0]=' ';
	MOVLW 32
	MOVWF Text
			;		Text[3]=0;
	CLRF  Text+3
			;		LCDString(Text);
	MOVLW 71
	MOVWF __putstr
	CALL  LCDString
			;	}
			;	else if (akt_status == ST_PURGE)
	GOTO  m124
m118	MOVF  akt_status,W
	XORLW 2
	BTFSS 0x03,Zero_
	GOTO  m119
			;	{
			;		LCDString("   ");
	MOVLW 163
	MOVWF __putstr
	CALL  LCDString
			;	}
			;	else if (akt_status == ST_FAIL) // Fehlerstatus ordentlich ausgeben
	GOTO  m124
m119	MOVF  akt_status,W
	XORLW 3
	BTFSS 0x03,Zero_
	GOTO  m124
			;	{
			;		LCDPos(0,0);
	CLRF  zeile
	MOVLW 0
	CALL  LCDPos
			;		
			;		LCDString("Err: ");
	MOVLW 167
	MOVWF __putstr
	CALL  LCDString
			;		
			;		switch (fcode)
	MOVF  fcode,W
	XORLW 2
	BTFSC 0x03,Zero_
	GOTO  m120
	XORLW 3
	BTFSC 0x03,Zero_
	GOTO  m121
	XORLW 2
	BTFSC 0x03,Zero_
	GOTO  m122
	GOTO  m123
			;		{
			;			case F_OVERT:	LCDString("Uebertemp");
m120	MOVLW 173
	MOVWF __putstr
	CALL  LCDString
			;					break;
	GOTO  m124
			;			case F_LOWT:	LCDString("Untertemp");
m121	MOVLW 183
	MOVWF __putstr
	CALL  LCDString
			;					break;
	GOTO  m124
			;			case F_FUELLZEIT:	LCDString("Fuellzeitmax");
m122	MOVLW 193
	MOVWF __putstr
	CALL  LCDString
			;					break;
	GOTO  m124
			;			default:	LCDString("unbekannt");
m123	MOVLW 206
	MOVWF __putstr
	CALL  LCDString
			;					break;
	GOTO  m124
			;		}
			;	}
			;	
			;	
			;	
			;	/* Ventil 2 erstmal nicht benutzt 
			;	if (V_IN2)
			;	{
			;		Text[9]='Z';	
			;	}
			;	else
			;	{
			;		Text[9]='-';
			;	}
			;	Text[10]=0; */
			;	
			;	// Wenn Backlight gefordert ist, anmachen
			;	if (lcdlight)
m124	MOVF  lcdlight,1
	BTFSC 0x03,Zero_
	GOTO  m125
			;	{
			;		LCD_BACKLIT = 1;
	BSF   PORTA,6
			;		lcdlight--;
	DECF  lcdlight,1
			;	}
			;	else
	GOTO  m126
			;	{
			;		LCD_BACKLIT = 0;	
m125	BCF   PORTA,6
			;	}
			;	
			;	
			;#pragma updateBank 1 /* ON, all cores */
			;}
m126	RETURN
			;
			;//
			;// --- Zeitcheck ---
			;//
			;// Gesamtzeit begrenzen
			;// liest: Gesamtzeit
			;// schreibt: -
			;//
			;void Zeitcheck(void)
			;{
Zeitcheck
			;	// 16k s = 4,5 Stunden... Laufzeit zuende-> alles aus, Strom sparen.
			;	if (Gesamtzeit.14)
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS Gesamtzeit+1,6
	GOTO  m128
			;	{
			;		LCDCls();
	CALL  LCDCls
			;		LCDPos(1,0);
	MOVLW 1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF zeile
	MOVLW 0
	CALL  LCDPos
			;		LCDString(" Beendet");
	MOVLW 216
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF __putstr
	CALL  LCDString
			;		
			;		LCD_BACKLIT = 0; // Licht aus
	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   PORTA,6
			;		NOP;		// zwei Nops wegen Timing read-mod-write am port
	NOP  
			;		NOP;
	NOP  
			;		LED_OFF = 1;	 // LED auf jeden Fall aus
	BSF   PORTA,7
			;		
			;		KW_VENTIL = VENTIL_ZU;
	BSF   PORTB,0
			;		NOP;		// zwei Nops wegen Timing read-mod-write am port
	NOP  
			;		NOP;
	NOP  
			;		WW_VENTIL = VENTIL_ZU;
	BSF   PORTB,1
			;		
			;		
			;		ADON = 0; 	// ADC ausschalten
	BCF   0x1F,ADON
			;		sleep();	// Strom sparen...
	SLEEP
			;		
			;		while (1);
m127	GOTO  m127
			;	}
			;}
m128	RETURN
			;
			;
			;/*------------------------------------------------------------------*/
			;/*     M     M    A    II  N   N                                    */
			;/*     MM   MM   A A   II  NN  N                                    */
			;/*     M M M M  A   A  II  N N N                                    */
			;/*     M  M  M  AAAAA  II  N  NN                                    */
			;/*     M     M  A   A  II  N   N                                    */
			;/*------------------------------------------------------------------*/
			;
			;void main (void)
			;{
main
			;		
			;	init();
	CALL  init
			;	
			;	LCDInit();	  // LCD Initialisieren
	CALL  LCDInit
			;		
			;	LCDCls();	 // LCD lschen
	CALL  LCDCls
			;	
			;	LCDPos(0,0);
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  zeile
	MOVLW 0
	CALL  LCDPos
			;	LCDString("Temp:");
	MOVLW 225
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF __putstr
	CALL  LCDString
			;	
			;	LCDPos(1,0);
	MOVLW 1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF zeile
	MOVLW 0
	CALL  LCDPos
			;	LCDString("WIMix 1.2");
	MOVLW 231
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF __putstr
	CALL  LCDString
			;	    
			;	temp_messen(); // Temperatur messen 
	CALL  temp_messen
			;
			;	KWTemp = ZulaufTemp.low8; // KW und WW erstmals belegen. Auflsung ZulaufTemp: etwa 0.5
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  ZulaufTemp,W
	MOVWF KWTemp
			;	WWTemp = KWTemp;
	MOVF  KWTemp,W
	MOVWF WWTemp
			;	
			;	LED_OFF = 1; // LED aus
	BSF   PORTA,7
			;		
			;	while (1)
			;	{	
			;		check_input();	// Ventil- und Tastenstatus lesen
m129	CALL  check_input
			;		
			;		Delay1ms(2);	// Zeitscheiben-Einteilung
	MOVLW 2
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;		
			;		temp_messen();	// Temperatur messen
	CALL  temp_messen
			;		
			;		update_tasten(); // Tasten einlesen
	CALL  update_tasten
			;		
			;		update_state();	// Status testen
	CALL  update_state
			;		
			;		update_vent();	// Ventilstatus bestimmen und Ventile steuern
	CALL  update_vent
			;		
			;		if (changed)
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS 0x46,changed
	GOTO  m130
			;		{
			;			update_LCD();	// Display updaten
	CALL  update_LCD
			;			LED_OFF ^= 1;
	MOVLW 128
	BCF   0x03,RP0
	BCF   0x03,RP1
	XORWF PORTA,1
			;			Zeitcheck();	// Ende der Laufzeit testen -> Endlos-Schleife
	CALL  Zeitcheck
			;		}
			;		
			;	}; // von while(immer)
m130	GOTO  m129

	END


; *** KEY INFO ***

; 0x0004   10 word(s)  0 % : int_server
; 0x0070   67 word(s)  3 % : init
; 0x00B3   26 word(s)  1 % : Delay1ms
; 0x00CD   51 word(s)  2 % : LCDWriteByte
; 0x0100   18 word(s)  0 % : LCDCommand
; 0x0112   22 word(s)  1 % : LCDCls
; 0x0128   30 word(s)  1 % : LCDString
; 0x000E   98 word(s)  4 % : _const1
; 0x0146   15 word(s)  0 % : LCDPos
; 0x0155  125 word(s)  6 % : LCDInit
; 0x01D2   43 word(s)  2 % : bin2dec999
; 0x01FD   22 word(s)  1 % : mul16
; 0x0213   26 word(s)  1 % : divide
; 0x022D  110 word(s)  5 % : MedianFilter
; 0x029B  104 word(s)  5 % : temp_messen
; 0x0303   64 word(s)  3 % : check_input
; 0x0343   33 word(s)  1 % : update_tasten
; 0x0364  154 word(s)  7 % : update_state
; 0x03FE  114 word(s)  5 % : update_vent
; 0x0470  161 word(s)  7 % : update_LCD
; 0x0511   30 word(s)  1 % : Zeitcheck
; 0x052F   54 word(s)  2 % : main

; RAM usage: 63 bytes (10 local), 193 bytes free
; Maximum call level: 3 (+1 for interrupt)
; Total of 1378 code words (67 %)
